/*
 * $Id: f_imageCombo.js,v 1.7 2007/01/24 21:38:18 oeuillot Exp $
 */

/**
 * class f_imageCombo
 *
 * @class f_imageCombo extends f_imageButton, fa_subMenu, fa_itemsWrapper
 * @author Olivier Oeuillot (latest modification by $Author: oeuillot $)
 * @version $Revision: 1.7 $ $Date: 2007/01/24 21:38:18 $
 */
var __static = {
	/**
	 * @field private static final String
	 */
	_MENU_ID: "#popup"
}

var __prototype = {

	f_imageCombo: function() {
		this.f_super(arguments);
		
		this.f_insertEventListenerFirst(f_event.KEYDOWN, this._onKeyDown);		
	},
	/** 
	 * @method private
	 */
	_onKeyDown: function(event) {
		var code=event.f_getJsEvent().keyCode;

		if (code!=f_key.VK_DOWN) {
			return true;
		}

		event.f_preventDefault();

		var menu=this.f_getSubMenuById(f_imageCombo._MENU_ID);
		if (menu) {
			menu.f_open(event.f_getJsEvent(), {
				component: this,
				position: f_popup.BOTTOM_COMPONENT
				});
		}
		
		return false;
	},
	/** 
	 * @method protected
	 */
	f_imageButtonSelect: function(evt) {
		f_core.Debug(f_imageCombo, "f_imageButtonSelect: evt="+evt);
		if (!this._focus)  {
			this.f_setFocus();
		}

		if (this.f_isReadOnly() || this.f_isDisabled()) {
			return false;
		}
		
		if (f_popup.VerifyMouseDown(this, evt._jsEvent)) {
			f_core.Debug(f_imageCombo, "f_imageButtonSelect: mouse down outside !");
			return false;
		}
		
		if (evt.f_getItem()) {
			// Selection d'un item !
			f_core.Debug(f_imageCombo, "f_imageButtonSelect: item already selected");
			return true;
		}
	
		var menu=this.f_getSubMenuById(f_imageCombo._MENU_ID);
		if (!menu) {
			f_core.Debug(f_imageCombo, "f_imageButtonSelect: no menu");
			return true;
		}
		
		menu.f_open(evt, {
			component: this,
			position: f_popup.BOTTOM_COMPONENT
			});
		
		f_core.Debug(f_imageCombo, "f_imageButtonSelect: Menu open (menu='"+menu+"')");
		return false;
	},
	fa_componentCaptureMenuEvent: function() {
		return this;
	},	
	fa_getItemsWrapper: function() {
		return this.f_getSubMenuById(f_imageCombo._MENU_ID);
	}
}		

new f_class("f_imageCombo", null, __static, __prototype, f_imageButton, fa_subMenu, fa_itemsWrapper);
